/* DisplayPlug.c generated by valac 0.56.14, the Vala compiler
 * generated from DisplayPlug.vala, do not modify */

/*-
 * Copyright (c) 2014-2023 elementary, Inc.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 *              Oleksandr Lynok <oleksandr.lynok@gmail.com>
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "display.h"
#include <gtk/gtk.h>
#include <switchboard.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gmodule.h>

enum  {
	DISPLAY_PLUG_0_PROPERTY,
	DISPLAY_PLUG_NUM_PROPERTIES
};
static GParamSpec* display_plug_properties[DISPLAY_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _DisplayPlugSearchData DisplayPlugSearchData;

struct _DisplayPlugPrivate {
	GtkBox* box;
	GtkStack* stack;
	DisplayDisplaysView* displays_view;
};

struct _DisplayPlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DisplayPlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* search_results;
	GCompareFunc _tmp0_;
	GEqualFunc _tmp1_;
	GeeTreeMap* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	const gchar* _tmp43_;
	const gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
};

static gint DisplayPlug_private_offset;
static gpointer display_plug_parent_class = NULL;
DisplayPlug* display_plug_plug = NULL;

static GtkWidget* display_plug_real_get_widget (SwitchboardPlug* base);
static void ___lambda53_ (DisplayPlug* self);
static void ____lambda53__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void display_plug_real_shown (SwitchboardPlug* base);
static void display_plug_real_hidden (SwitchboardPlug* base);
static void display_plug_real_search_callback (SwitchboardPlug* base,
                                        const gchar* location);
static void display_plug_real_search_data_free (gpointer _data);
static void display_plug_real_search (SwitchboardPlug* base,
                               const gchar* search,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
static gboolean display_plug_real_search_co (DisplayPlugSearchData* _data_);
static void display_plug_finalize (GObject * obj);
static GType display_plug_get_type_once (void);

static inline gpointer
display_plug_get_instance_private (DisplayPlug* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayPlug_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 42 "../src/DisplayPlug.vala"
	return self ? g_object_ref (self) : NULL;
#line 160 "DisplayPlug.c"
}

DisplayPlug*
display_plug_construct (GType object_type)
{
	DisplayPlug * self = NULL;
	GeeTreeMap* settings = NULL;
	GeeTreeMap* _tmp0_;
	DisplayPlug* _tmp1_;
#line 30 "../src/DisplayPlug.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 31 "../src/DisplayPlug.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 33 "../src/DisplayPlug.vala"
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 33 "../src/DisplayPlug.vala"
	settings = _tmp0_;
#line 34 "../src/DisplayPlug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "display", NULL);
#line 35 "../src/DisplayPlug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "display/night-light", "night-light");
#line 36 "../src/DisplayPlug.vala"
	self = (DisplayPlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_HARDWARE, "code-name", "io.elementary.switchboard.display", "display-name", _ ("Displays"), "description", _ ("Configure resolution and position of monitors and projectors"), "icon", "preferences-desktop-display", "supported-settings", settings, NULL);
#line 42 "../src/DisplayPlug.vala"
	_tmp1_ = _g_object_ref0 (self);
#line 42 "../src/DisplayPlug.vala"
	_g_object_unref0 (display_plug_plug);
#line 42 "../src/DisplayPlug.vala"
	display_plug_plug = _tmp1_;
#line 29 "../src/DisplayPlug.vala"
	_g_object_unref0 (settings);
#line 29 "../src/DisplayPlug.vala"
	return self;
#line 194 "DisplayPlug.c"
}

DisplayPlug*
display_plug_new (void)
{
#line 29 "../src/DisplayPlug.vala"
	return display_plug_construct (DISPLAY_TYPE_PLUG);
#line 202 "DisplayPlug.c"
}

static void
___lambda53_ (DisplayPlug* self)
{
	GtkStack* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	DisplayDisplaysView* _tmp3_;
#line 80 "../src/DisplayPlug.vala"
	_tmp0_ = self->priv->stack;
#line 80 "../src/DisplayPlug.vala"
	_tmp1_ = gtk_stack_get_visible_child (_tmp0_);
#line 80 "../src/DisplayPlug.vala"
	_tmp2_ = _tmp1_;
#line 80 "../src/DisplayPlug.vala"
	_tmp3_ = self->priv->displays_view;
#line 80 "../src/DisplayPlug.vala"
	if (_tmp2_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget)) {
#line 222 "DisplayPlug.c"
		DisplayDisplaysView* _tmp4_;
		DisplayDisplaysOverlay* _tmp5_;
#line 81 "../src/DisplayPlug.vala"
		_tmp4_ = self->priv->displays_view;
#line 81 "../src/DisplayPlug.vala"
		_tmp5_ = _tmp4_->displays_overlay;
#line 81 "../src/DisplayPlug.vala"
		display_displays_overlay_show_windows (_tmp5_);
#line 231 "DisplayPlug.c"
	} else {
		DisplayDisplaysView* _tmp6_;
		DisplayDisplaysOverlay* _tmp7_;
#line 83 "../src/DisplayPlug.vala"
		_tmp6_ = self->priv->displays_view;
#line 83 "../src/DisplayPlug.vala"
		_tmp7_ = _tmp6_->displays_overlay;
#line 83 "../src/DisplayPlug.vala"
		display_displays_overlay_hide_windows (_tmp7_);
#line 241 "DisplayPlug.c"
	}
}

static void
____lambda53__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 79 "../src/DisplayPlug.vala"
	___lambda53_ ((DisplayPlug*) self);
#line 252 "DisplayPlug.c"
}

static GtkWidget*
display_plug_real_get_widget (SwitchboardPlug* base)
{
	DisplayPlug * self;
	GtkBox* _tmp0_;
	GtkBox* _tmp31_;
	GtkWidget* _tmp32_;
	GtkWidget* result;
#line 45 "../src/DisplayPlug.vala"
	self = (DisplayPlug*) base;
#line 46 "../src/DisplayPlug.vala"
	_tmp0_ = self->priv->box;
#line 46 "../src/DisplayPlug.vala"
	if (_tmp0_ == NULL) {
#line 269 "DisplayPlug.c"
		DisplayDisplaysView* _tmp1_;
		GtkStack* _tmp2_;
		GtkStack* _tmp3_;
		DisplayDisplaysView* _tmp4_;
		GSettingsSchema* interface_settings_schema = NULL;
		GSettingsSchemaSource* _tmp5_;
		GSettingsSchema* _tmp6_;
		gboolean _tmp7_ = FALSE;
		GSettingsSchema* _tmp8_;
		GSettingsSchema* filters_settings_schema = NULL;
		GSettingsSchemaSource* _tmp13_;
		GSettingsSchema* _tmp14_;
		gboolean _tmp15_ = FALSE;
		GSettingsSchema* _tmp16_;
		GtkStackSwitcher* stack_switcher = NULL;
		GtkStack* _tmp21_;
		GtkStack* _tmp22_;
		GtkStackSwitcher* _tmp23_ = NULL;
		GtkBox* _tmp24_;
		GtkBox* _tmp25_;
		GtkStackSwitcher* _tmp26_;
		GtkBox* _tmp27_;
		GtkStack* _tmp28_;
		GtkBox* _tmp29_;
		GtkStack* _tmp30_;
#line 47 "../src/DisplayPlug.vala"
		_tmp1_ = display_displays_view_new ();
#line 47 "../src/DisplayPlug.vala"
		g_object_ref_sink (_tmp1_);
#line 47 "../src/DisplayPlug.vala"
		_g_object_unref0 (self->priv->displays_view);
#line 47 "../src/DisplayPlug.vala"
		self->priv->displays_view = _tmp1_;
#line 49 "../src/DisplayPlug.vala"
		_tmp2_ = (GtkStack*) gtk_stack_new ();
#line 49 "../src/DisplayPlug.vala"
		g_object_ref_sink (_tmp2_);
#line 49 "../src/DisplayPlug.vala"
		_g_object_unref0 (self->priv->stack);
#line 49 "../src/DisplayPlug.vala"
		self->priv->stack = _tmp2_;
#line 50 "../src/DisplayPlug.vala"
		_tmp3_ = self->priv->stack;
#line 50 "../src/DisplayPlug.vala"
		_tmp4_ = self->priv->displays_view;
#line 50 "../src/DisplayPlug.vala"
		gtk_stack_add_titled (_tmp3_, (GtkWidget*) _tmp4_, "displays", _ ("Displays"));
#line 52 "../src/DisplayPlug.vala"
		_tmp5_ = g_settings_schema_source_get_default ();
#line 52 "../src/DisplayPlug.vala"
		_tmp6_ = g_settings_schema_source_lookup (_tmp5_, "org.gnome.settings-daemon.plugins.color", TRUE);
#line 52 "../src/DisplayPlug.vala"
		interface_settings_schema = _tmp6_;
#line 53 "../src/DisplayPlug.vala"
		_tmp8_ = interface_settings_schema;
#line 53 "../src/DisplayPlug.vala"
		if (_tmp8_ != NULL) {
#line 327 "DisplayPlug.c"
			GSettingsSchema* _tmp9_;
#line 53 "../src/DisplayPlug.vala"
			_tmp9_ = interface_settings_schema;
#line 53 "../src/DisplayPlug.vala"
			_tmp7_ = g_settings_schema_has_key (_tmp9_, "night-light-enabled");
#line 333 "DisplayPlug.c"
		} else {
#line 53 "../src/DisplayPlug.vala"
			_tmp7_ = FALSE;
#line 337 "DisplayPlug.c"
		}
#line 53 "../src/DisplayPlug.vala"
		if (_tmp7_) {
#line 341 "DisplayPlug.c"
			DisplayNightLightView* nightlight_view = NULL;
			DisplayNightLightView* _tmp10_;
			GtkStack* _tmp11_;
			DisplayNightLightView* _tmp12_;
#line 54 "../src/DisplayPlug.vala"
			_tmp10_ = display_night_light_view_new ();
#line 54 "../src/DisplayPlug.vala"
			g_object_ref_sink (_tmp10_);
#line 54 "../src/DisplayPlug.vala"
			nightlight_view = _tmp10_;
#line 55 "../src/DisplayPlug.vala"
			_tmp11_ = self->priv->stack;
#line 55 "../src/DisplayPlug.vala"
			_tmp12_ = nightlight_view;
#line 55 "../src/DisplayPlug.vala"
			gtk_stack_add_titled (_tmp11_, (GtkWidget*) _tmp12_, "night-light", _ ("Night Light"));
#line 53 "../src/DisplayPlug.vala"
			_g_object_unref0 (nightlight_view);
#line 360 "DisplayPlug.c"
		}
#line 58 "../src/DisplayPlug.vala"
		_tmp13_ = g_settings_schema_source_get_default ();
#line 58 "../src/DisplayPlug.vala"
		_tmp14_ = g_settings_schema_source_lookup (_tmp13_, "io.elementary.desktop.wm.accessibility", TRUE);
#line 58 "../src/DisplayPlug.vala"
		filters_settings_schema = _tmp14_;
#line 59 "../src/DisplayPlug.vala"
		_tmp16_ = filters_settings_schema;
#line 59 "../src/DisplayPlug.vala"
		if (_tmp16_ != NULL) {
#line 372 "DisplayPlug.c"
			GSettingsSchema* _tmp17_;
#line 59 "../src/DisplayPlug.vala"
			_tmp17_ = filters_settings_schema;
#line 59 "../src/DisplayPlug.vala"
			_tmp15_ = g_settings_schema_has_key (_tmp17_, "colorblindness-correction-filter");
#line 378 "DisplayPlug.c"
		} else {
#line 59 "../src/DisplayPlug.vala"
			_tmp15_ = FALSE;
#line 382 "DisplayPlug.c"
		}
#line 59 "../src/DisplayPlug.vala"
		if (_tmp15_) {
#line 386 "DisplayPlug.c"
			DisplayFiltersView* filters_view = NULL;
			DisplayFiltersView* _tmp18_;
			GtkStack* _tmp19_;
			DisplayFiltersView* _tmp20_;
#line 60 "../src/DisplayPlug.vala"
			_tmp18_ = display_filters_view_new ();
#line 60 "../src/DisplayPlug.vala"
			g_object_ref_sink (_tmp18_);
#line 60 "../src/DisplayPlug.vala"
			filters_view = _tmp18_;
#line 61 "../src/DisplayPlug.vala"
			_tmp19_ = self->priv->stack;
#line 61 "../src/DisplayPlug.vala"
			_tmp20_ = filters_view;
#line 61 "../src/DisplayPlug.vala"
			gtk_stack_add_titled (_tmp19_, (GtkWidget*) _tmp20_, "filters", _ ("Filters"));
#line 59 "../src/DisplayPlug.vala"
			_g_object_unref0 (filters_view);
#line 405 "DisplayPlug.c"
		}
#line 64 "../src/DisplayPlug.vala"
		_tmp21_ = self->priv->stack;
#line 64 "../src/DisplayPlug.vala"
		_tmp22_ = _g_object_ref0 (_tmp21_);
#line 64 "../src/DisplayPlug.vala"
		_tmp23_ = (GtkStackSwitcher*) gtk_stack_switcher_new ();
#line 64 "../src/DisplayPlug.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp23_, GTK_ALIGN_CENTER);
#line 64 "../src/DisplayPlug.vala"
		gtk_box_set_homogeneous ((GtkBox*) _tmp23_, TRUE);
#line 64 "../src/DisplayPlug.vala"
		gtk_widget_set_margin_top ((GtkWidget*) _tmp23_, 12);
#line 64 "../src/DisplayPlug.vala"
		gtk_widget_set_margin_end ((GtkWidget*) _tmp23_, 12);
#line 64 "../src/DisplayPlug.vala"
		gtk_widget_set_margin_bottom ((GtkWidget*) _tmp23_, 12);
#line 64 "../src/DisplayPlug.vala"
		gtk_widget_set_margin_start ((GtkWidget*) _tmp23_, 12);
#line 64 "../src/DisplayPlug.vala"
		gtk_stack_switcher_set_stack (_tmp23_, _tmp22_);
#line 64 "../src/DisplayPlug.vala"
		_g_object_unref0 (_tmp22_);
#line 64 "../src/DisplayPlug.vala"
		g_object_ref_sink (_tmp23_);
#line 64 "../src/DisplayPlug.vala"
		stack_switcher = _tmp23_;
#line 74 "../src/DisplayPlug.vala"
		_tmp24_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 74 "../src/DisplayPlug.vala"
		g_object_ref_sink (_tmp24_);
#line 74 "../src/DisplayPlug.vala"
		_g_object_unref0 (self->priv->box);
#line 74 "../src/DisplayPlug.vala"
		self->priv->box = _tmp24_;
#line 75 "../src/DisplayPlug.vala"
		_tmp25_ = self->priv->box;
#line 75 "../src/DisplayPlug.vala"
		_tmp26_ = stack_switcher;
#line 75 "../src/DisplayPlug.vala"
		gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _tmp26_);
#line 76 "../src/DisplayPlug.vala"
		_tmp27_ = self->priv->box;
#line 76 "../src/DisplayPlug.vala"
		_tmp28_ = self->priv->stack;
#line 76 "../src/DisplayPlug.vala"
		gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
#line 77 "../src/DisplayPlug.vala"
		_tmp29_ = self->priv->box;
#line 77 "../src/DisplayPlug.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp29_);
#line 79 "../src/DisplayPlug.vala"
		_tmp30_ = self->priv->stack;
#line 79 "../src/DisplayPlug.vala"
		g_signal_connect_object ((GObject*) _tmp30_, "notify::visible-child", (GCallback) ____lambda53__g_object_notify, self, 0);
#line 46 "../src/DisplayPlug.vala"
		_g_object_unref0 (stack_switcher);
#line 46 "../src/DisplayPlug.vala"
		_g_settings_schema_unref0 (filters_settings_schema);
#line 46 "../src/DisplayPlug.vala"
		_g_settings_schema_unref0 (interface_settings_schema);
#line 467 "DisplayPlug.c"
	}
#line 88 "../src/DisplayPlug.vala"
	_tmp31_ = self->priv->box;
#line 88 "../src/DisplayPlug.vala"
	_tmp32_ = _g_object_ref0 ((GtkWidget*) _tmp31_);
#line 88 "../src/DisplayPlug.vala"
	result = _tmp32_;
#line 88 "../src/DisplayPlug.vala"
	return result;
#line 477 "DisplayPlug.c"
}

static void
display_plug_real_shown (SwitchboardPlug* base)
{
	DisplayPlug * self;
	GtkStack* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	DisplayDisplaysView* _tmp3_;
#line 91 "../src/DisplayPlug.vala"
	self = (DisplayPlug*) base;
#line 92 "../src/DisplayPlug.vala"
	_tmp0_ = self->priv->stack;
#line 92 "../src/DisplayPlug.vala"
	_tmp1_ = gtk_stack_get_visible_child (_tmp0_);
#line 92 "../src/DisplayPlug.vala"
	_tmp2_ = _tmp1_;
#line 92 "../src/DisplayPlug.vala"
	_tmp3_ = self->priv->displays_view;
#line 92 "../src/DisplayPlug.vala"
	if (_tmp2_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget)) {
#line 500 "DisplayPlug.c"
		DisplayDisplaysView* _tmp4_;
		DisplayDisplaysOverlay* _tmp5_;
#line 93 "../src/DisplayPlug.vala"
		_tmp4_ = self->priv->displays_view;
#line 93 "../src/DisplayPlug.vala"
		_tmp5_ = _tmp4_->displays_overlay;
#line 93 "../src/DisplayPlug.vala"
		display_displays_overlay_show_windows (_tmp5_);
#line 509 "DisplayPlug.c"
	} else {
		DisplayDisplaysView* _tmp6_;
		DisplayDisplaysOverlay* _tmp7_;
#line 95 "../src/DisplayPlug.vala"
		_tmp6_ = self->priv->displays_view;
#line 95 "../src/DisplayPlug.vala"
		_tmp7_ = _tmp6_->displays_overlay;
#line 95 "../src/DisplayPlug.vala"
		display_displays_overlay_hide_windows (_tmp7_);
#line 519 "DisplayPlug.c"
	}
}

static void
display_plug_real_hidden (SwitchboardPlug* base)
{
	DisplayPlug * self;
	DisplayDisplaysView* _tmp0_;
	DisplayDisplaysOverlay* _tmp1_;
#line 99 "../src/DisplayPlug.vala"
	self = (DisplayPlug*) base;
#line 100 "../src/DisplayPlug.vala"
	_tmp0_ = self->priv->displays_view;
#line 100 "../src/DisplayPlug.vala"
	_tmp1_ = _tmp0_->displays_overlay;
#line 100 "../src/DisplayPlug.vala"
	display_displays_overlay_hide_windows (_tmp1_);
#line 537 "DisplayPlug.c"
}

static void
display_plug_real_search_callback (SwitchboardPlug* base,
                                   const gchar* location)
{
	DisplayPlug * self;
	GtkStack* _tmp0_;
#line 103 "../src/DisplayPlug.vala"
	self = (DisplayPlug*) base;
#line 103 "../src/DisplayPlug.vala"
	g_return_if_fail (location != NULL);
#line 104 "../src/DisplayPlug.vala"
	_tmp0_ = self->priv->stack;
#line 104 "../src/DisplayPlug.vala"
	gtk_stack_set_visible_child_name (_tmp0_, location);
#line 554 "DisplayPlug.c"
}

static void
display_plug_real_search_data_free (gpointer _data)
{
	DisplayPlugSearchData* _data_;
	_data_ = _data;
#line 23 "../src/DisplayPlug.vala"
	_g_free0 (_data_->search);
#line 23 "../src/DisplayPlug.vala"
	_g_object_unref0 (_data_->result);
#line 23 "../src/DisplayPlug.vala"
	_g_object_unref0 (_data_->self);
#line 23 "../src/DisplayPlug.vala"
	g_slice_free (DisplayPlugSearchData, _data_);
#line 570 "DisplayPlug.c"
}

static void
display_plug_real_search (SwitchboardPlug* base,
                          const gchar* search,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	DisplayPlug * self;
	DisplayPlugSearchData* _data_;
	DisplayPlug* _tmp0_;
	gchar* _tmp1_;
#line 23 "../src/DisplayPlug.vala"
	g_return_if_fail (search != NULL);
#line 23 "../src/DisplayPlug.vala"
	self = (DisplayPlug*) base;
#line 23 "../src/DisplayPlug.vala"
	_data_ = g_slice_new0 (DisplayPlugSearchData);
#line 23 "../src/DisplayPlug.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 23 "../src/DisplayPlug.vala"
	g_task_set_task_data (_data_->_async_result, _data_, display_plug_real_search_data_free);
#line 23 "../src/DisplayPlug.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 23 "../src/DisplayPlug.vala"
	_data_->self = _tmp0_;
#line 23 "../src/DisplayPlug.vala"
	_tmp1_ = g_strdup (search);
#line 23 "../src/DisplayPlug.vala"
	_g_free0 (_data_->search);
#line 23 "../src/DisplayPlug.vala"
	_data_->search = _tmp1_;
#line 23 "../src/DisplayPlug.vala"
	display_plug_real_search_co (_data_);
#line 605 "DisplayPlug.c"
}

static GeeTreeMap*
display_plug_search_finish (SwitchboardPlug* base,
                            GAsyncResult* _res_)
{
	GeeTreeMap* result;
	DisplayPlugSearchData* _data_;
#line 23 "../src/DisplayPlug.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 23 "../src/DisplayPlug.vala"
	result = _data_->result;
#line 23 "../src/DisplayPlug.vala"
	_data_->result = NULL;
#line 23 "../src/DisplayPlug.vala"
	return result;
#line 622 "DisplayPlug.c"
}

static gboolean
display_plug_real_search_co (DisplayPlugSearchData* _data_)
{
#line 108 "../src/DisplayPlug.vala"
	switch (_data_->_state_) {
#line 108 "../src/DisplayPlug.vala"
		case 0:
#line 632 "DisplayPlug.c"
		goto _state_0;
		default:
#line 108 "../src/DisplayPlug.vala"
		g_assert_not_reached ();
#line 637 "DisplayPlug.c"
	}
	_state_0:
#line 109 "../src/DisplayPlug.vala"
	_data_->_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 109 "../src/DisplayPlug.vala"
	_data_->_tmp1_ = g_str_equal;
#line 109 "../src/DisplayPlug.vala"
	_data_->_tmp2_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, (GCompareDataFunc) _data_->_tmp0_, NULL, NULL, (GeeEqualDataFunc) _data_->_tmp1_, NULL, NULL);
#line 109 "../src/DisplayPlug.vala"
	_data_->search_results = _data_->_tmp2_;
#line 110 "../src/DisplayPlug.vala"
	_data_->_tmp3_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 110 "../src/DisplayPlug.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 110 "../src/DisplayPlug.vala"
	_data_->_tmp5_ = g_strdup_printf ("%s → %s", _data_->_tmp4_, _ ("Screen Resolution"));
#line 110 "../src/DisplayPlug.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 110 "../src/DisplayPlug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp6_, "displays");
#line 110 "../src/DisplayPlug.vala"
	_g_free0 (_data_->_tmp6_);
#line 111 "../src/DisplayPlug.vala"
	_data_->_tmp7_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 111 "../src/DisplayPlug.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 111 "../src/DisplayPlug.vala"
	_data_->_tmp9_ = g_strdup_printf ("%s → %s", _data_->_tmp8_, _ ("Screen Rotation"));
#line 111 "../src/DisplayPlug.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 111 "../src/DisplayPlug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp10_, "displays");
#line 111 "../src/DisplayPlug.vala"
	_g_free0 (_data_->_tmp10_);
#line 112 "../src/DisplayPlug.vala"
	_data_->_tmp11_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 112 "../src/DisplayPlug.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 112 "../src/DisplayPlug.vala"
	_data_->_tmp13_ = g_strdup_printf ("%s → %s", _data_->_tmp12_, _ ("Primary display"));
#line 112 "../src/DisplayPlug.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 112 "../src/DisplayPlug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp14_, "displays");
#line 112 "../src/DisplayPlug.vala"
	_g_free0 (_data_->_tmp14_);
#line 113 "../src/DisplayPlug.vala"
	_data_->_tmp15_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 113 "../src/DisplayPlug.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 113 "../src/DisplayPlug.vala"
	_data_->_tmp17_ = g_strdup_printf ("%s → %s", _data_->_tmp16_, _ ("Screen mirroring"));
#line 113 "../src/DisplayPlug.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 113 "../src/DisplayPlug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp18_, "displays");
#line 113 "../src/DisplayPlug.vala"
	_g_free0 (_data_->_tmp18_);
#line 114 "../src/DisplayPlug.vala"
	_data_->_tmp19_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 114 "../src/DisplayPlug.vala"
	_data_->_tmp20_ = _data_->_tmp19_;
#line 114 "../src/DisplayPlug.vala"
	_data_->_tmp21_ = g_strdup_printf ("%s → %s", _data_->_tmp20_, _ ("Scaling factor"));
#line 114 "../src/DisplayPlug.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 114 "../src/DisplayPlug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp22_, "displays");
#line 114 "../src/DisplayPlug.vala"
	_g_free0 (_data_->_tmp22_);
#line 115 "../src/DisplayPlug.vala"
	_data_->_tmp23_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 115 "../src/DisplayPlug.vala"
	_data_->_tmp24_ = _data_->_tmp23_;
#line 115 "../src/DisplayPlug.vala"
	_data_->_tmp25_ = g_strdup_printf ("%s → %s", _data_->_tmp24_, _ ("Rotation lock"));
#line 115 "../src/DisplayPlug.vala"
	_data_->_tmp26_ = _data_->_tmp25_;
#line 115 "../src/DisplayPlug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp26_, "displays");
#line 115 "../src/DisplayPlug.vala"
	_g_free0 (_data_->_tmp26_);
#line 116 "../src/DisplayPlug.vala"
	_data_->_tmp27_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 116 "../src/DisplayPlug.vala"
	_data_->_tmp28_ = _data_->_tmp27_;
#line 116 "../src/DisplayPlug.vala"
	_data_->_tmp29_ = g_strdup_printf ("%s → %s", _data_->_tmp28_, _ ("Night Light"));
#line 116 "../src/DisplayPlug.vala"
	_data_->_tmp30_ = _data_->_tmp29_;
#line 116 "../src/DisplayPlug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp30_, "night-light");
#line 116 "../src/DisplayPlug.vala"
	_g_free0 (_data_->_tmp30_);
#line 117 "../src/DisplayPlug.vala"
	_data_->_tmp31_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 117 "../src/DisplayPlug.vala"
	_data_->_tmp32_ = _data_->_tmp31_;
#line 117 "../src/DisplayPlug.vala"
	_data_->_tmp33_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp32_, _ ("Night Light"), _ ("Schedule"));
#line 117 "../src/DisplayPlug.vala"
	_data_->_tmp34_ = _data_->_tmp33_;
#line 117 "../src/DisplayPlug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp34_, "night-light");
#line 117 "../src/DisplayPlug.vala"
	_g_free0 (_data_->_tmp34_);
#line 118 "../src/DisplayPlug.vala"
	_data_->_tmp35_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 118 "../src/DisplayPlug.vala"
	_data_->_tmp36_ = _data_->_tmp35_;
#line 118 "../src/DisplayPlug.vala"
	_data_->_tmp37_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp36_, _ ("Night Light"), _ ("Color temperature"));
#line 118 "../src/DisplayPlug.vala"
	_data_->_tmp38_ = _data_->_tmp37_;
#line 118 "../src/DisplayPlug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp38_, "night-light");
#line 118 "../src/DisplayPlug.vala"
	_g_free0 (_data_->_tmp38_);
#line 119 "../src/DisplayPlug.vala"
	_data_->_tmp39_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 119 "../src/DisplayPlug.vala"
	_data_->_tmp40_ = _data_->_tmp39_;
#line 119 "../src/DisplayPlug.vala"
	_data_->_tmp41_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp40_, _ ("Filters"), _ ("Color Blindness"));
#line 119 "../src/DisplayPlug.vala"
	_data_->_tmp42_ = _data_->_tmp41_;
#line 119 "../src/DisplayPlug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp42_, "filters");
#line 119 "../src/DisplayPlug.vala"
	_g_free0 (_data_->_tmp42_);
#line 120 "../src/DisplayPlug.vala"
	_data_->_tmp43_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 120 "../src/DisplayPlug.vala"
	_data_->_tmp44_ = _data_->_tmp43_;
#line 120 "../src/DisplayPlug.vala"
	_data_->_tmp45_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp44_, _ ("Filters"), _ ("Color Vision Deficiency"));
#line 120 "../src/DisplayPlug.vala"
	_data_->_tmp46_ = _data_->_tmp45_;
#line 120 "../src/DisplayPlug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp46_, "filters");
#line 120 "../src/DisplayPlug.vala"
	_g_free0 (_data_->_tmp46_);
#line 121 "../src/DisplayPlug.vala"
	_data_->_tmp47_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 121 "../src/DisplayPlug.vala"
	_data_->_tmp48_ = _data_->_tmp47_;
#line 121 "../src/DisplayPlug.vala"
	_data_->_tmp49_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp48_, _ ("Filters"), _ ("Grayscale"));
#line 121 "../src/DisplayPlug.vala"
	_data_->_tmp50_ = _data_->_tmp49_;
#line 121 "../src/DisplayPlug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp50_, "filters");
#line 121 "../src/DisplayPlug.vala"
	_g_free0 (_data_->_tmp50_);
#line 122 "../src/DisplayPlug.vala"
	_data_->_tmp51_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 122 "../src/DisplayPlug.vala"
	_data_->_tmp52_ = _data_->_tmp51_;
#line 122 "../src/DisplayPlug.vala"
	_data_->_tmp53_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp52_, _ ("Filters"), _ ("Monochrome"));
#line 122 "../src/DisplayPlug.vala"
	_data_->_tmp54_ = _data_->_tmp53_;
#line 122 "../src/DisplayPlug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp54_, "filters");
#line 122 "../src/DisplayPlug.vala"
	_g_free0 (_data_->_tmp54_);
#line 123 "../src/DisplayPlug.vala"
	_data_->result = _data_->search_results;
#line 123 "../src/DisplayPlug.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 123 "../src/DisplayPlug.vala"
	if (_data_->_state_ != 0) {
#line 123 "../src/DisplayPlug.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 123 "../src/DisplayPlug.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 814 "DisplayPlug.c"
		}
	}
#line 123 "../src/DisplayPlug.vala"
	g_object_unref (_data_->_async_result);
#line 123 "../src/DisplayPlug.vala"
	return FALSE;
#line 821 "DisplayPlug.c"
}

static void
display_plug_class_init (DisplayPlugClass * klass,
                         gpointer klass_data)
{
#line 23 "../src/DisplayPlug.vala"
	display_plug_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/DisplayPlug.vala"
	g_type_class_adjust_private_offset (klass, &DisplayPlug_private_offset);
#line 23 "../src/DisplayPlug.vala"
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug*)) display_plug_real_get_widget;
#line 23 "../src/DisplayPlug.vala"
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug*)) display_plug_real_shown;
#line 23 "../src/DisplayPlug.vala"
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug*)) display_plug_real_hidden;
#line 23 "../src/DisplayPlug.vala"
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug*, const gchar*)) display_plug_real_search_callback;
#line 23 "../src/DisplayPlug.vala"
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug*, const gchar*, GAsyncReadyCallback, gpointer)) display_plug_real_search;
#line 23 "../src/DisplayPlug.vala"
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug*, GAsyncResult*)) display_plug_search_finish;
#line 23 "../src/DisplayPlug.vala"
	G_OBJECT_CLASS (klass)->finalize = display_plug_finalize;
#line 846 "DisplayPlug.c"
}

static void
display_plug_instance_init (DisplayPlug * self,
                            gpointer klass)
{
#line 23 "../src/DisplayPlug.vala"
	self->priv = display_plug_get_instance_private (self);
#line 855 "DisplayPlug.c"
}

static void
display_plug_finalize (GObject * obj)
{
	DisplayPlug * self;
#line 23 "../src/DisplayPlug.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_PLUG, DisplayPlug);
#line 25 "../src/DisplayPlug.vala"
	_g_object_unref0 (self->priv->box);
#line 26 "../src/DisplayPlug.vala"
	_g_object_unref0 (self->priv->stack);
#line 27 "../src/DisplayPlug.vala"
	_g_object_unref0 (self->priv->displays_view);
#line 23 "../src/DisplayPlug.vala"
	G_OBJECT_CLASS (display_plug_parent_class)->finalize (obj);
#line 872 "DisplayPlug.c"
}

static GType
display_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayPlug), 0, (GInstanceInitFunc) display_plug_instance_init, NULL };
	GType display_plug_type_id;
	display_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "DisplayPlug", &g_define_type_info, 0);
	DisplayPlug_private_offset = g_type_add_instance_private (display_plug_type_id, sizeof (DisplayPlugPrivate));
	return display_plug_type_id;
}

GType
display_plug_get_type (void)
{
	static volatile gsize display_plug_type_id__once = 0;
	if (g_once_init_enter (&display_plug_type_id__once)) {
		GType display_plug_type_id;
		display_plug_type_id = display_plug_get_type_once ();
		g_once_init_leave (&display_plug_type_id__once, display_plug_type_id);
	}
	return display_plug_type_id__once;
}

SwitchboardPlug*
get_plug (GModule* module)
{
	DisplayPlug* plug = NULL;
	DisplayPlug* _tmp0_;
	SwitchboardPlug* result;
#line 127 "../src/DisplayPlug.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 128 "../src/DisplayPlug.vala"
	g_debug ("DisplayPlug.vala:128: Activating Display plug");
#line 129 "../src/DisplayPlug.vala"
	_tmp0_ = display_plug_new ();
#line 129 "../src/DisplayPlug.vala"
	plug = _tmp0_;
#line 130 "../src/DisplayPlug.vala"
	result = (SwitchboardPlug*) plug;
#line 130 "../src/DisplayPlug.vala"
	return result;
#line 915 "DisplayPlug.c"
}

