/* Monitor.c generated by valac 0.56.14, the Vala compiler
 * generated from Monitor.vala, do not modify */

/*-
 * Copyright (c) 2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "display.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>

enum  {
	DISPLAY_MONITOR_0_PROPERTY,
	DISPLAY_MONITOR_CONNECTOR_PROPERTY,
	DISPLAY_MONITOR_VENDOR_PROPERTY,
	DISPLAY_MONITOR_PRODUCT_PROPERTY,
	DISPLAY_MONITOR_SERIAL_PROPERTY,
	DISPLAY_MONITOR_HASH_PROPERTY,
	DISPLAY_MONITOR_DISPLAY_NAME_PROPERTY,
	DISPLAY_MONITOR_IS_BUILTIN_PROPERTY,
	DISPLAY_MONITOR_MODES_PROPERTY,
	DISPLAY_MONITOR_CURRENT_MODE_PROPERTY,
	DISPLAY_MONITOR_PREFERRED_MODE_PROPERTY,
	DISPLAY_MONITOR_NUM_PROPERTIES
};
static GParamSpec* display_monitor_properties[DISPLAY_MONITOR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _DisplayMonitorPrivate {
	gchar* _connector;
	gchar* _vendor;
	gchar* _product;
	gchar* _serial;
	gchar* _display_name;
	gboolean _is_builtin;
	GeeLinkedList* _modes;
};

static gint DisplayMonitor_private_offset;
static gpointer display_monitor_parent_class = NULL;

static GObject * display_monitor_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void display_monitor_finalize (GObject * obj);
static GType display_monitor_get_type_once (void);
static void _vala_display_monitor_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_display_monitor_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
display_monitor_get_instance_private (DisplayMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayMonitor_private_offset);
}

gdouble
display_monitor_get_max_scale (DisplayMonitor* self)
{
	gdouble max_scale = 0.0;
	gdouble result;
#line 61 "../src/Objects/Monitor.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 62 "../src/Objects/Monitor.vala"
	max_scale = 1.0;
#line 103 "Monitor.c"
	{
		GeeLinkedList* _mode_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _mode_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _mode_index = 0;
#line 63 "../src/Objects/Monitor.vala"
		_tmp0_ = self->priv->_modes;
#line 63 "../src/Objects/Monitor.vala"
		_mode_list = _tmp0_;
#line 63 "../src/Objects/Monitor.vala"
		_tmp1_ = _mode_list;
#line 63 "../src/Objects/Monitor.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 63 "../src/Objects/Monitor.vala"
		_tmp3_ = _tmp2_;
#line 63 "../src/Objects/Monitor.vala"
		_mode_size = _tmp3_;
#line 63 "../src/Objects/Monitor.vala"
		_mode_index = -1;
#line 63 "../src/Objects/Monitor.vala"
		while (TRUE) {
#line 128 "Monitor.c"
			gint _tmp4_;
			gint _tmp5_;
			DisplayMonitorMode* mode = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			DisplayMonitorMode* _tmp8_;
			gdouble* _tmp9_;
			gint _tmp9__length1;
#line 63 "../src/Objects/Monitor.vala"
			_mode_index = _mode_index + 1;
#line 63 "../src/Objects/Monitor.vala"
			_tmp4_ = _mode_index;
#line 63 "../src/Objects/Monitor.vala"
			_tmp5_ = _mode_size;
#line 63 "../src/Objects/Monitor.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 63 "../src/Objects/Monitor.vala"
				break;
#line 147 "Monitor.c"
			}
#line 63 "../src/Objects/Monitor.vala"
			_tmp6_ = _mode_list;
#line 63 "../src/Objects/Monitor.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _mode_index);
#line 63 "../src/Objects/Monitor.vala"
			mode = (DisplayMonitorMode*) _tmp7_;
#line 64 "../src/Objects/Monitor.vala"
			_tmp8_ = mode;
#line 64 "../src/Objects/Monitor.vala"
			_tmp9_ = _tmp8_->supported_scales;
#line 64 "../src/Objects/Monitor.vala"
			_tmp9__length1 = _tmp8_->supported_scales_length1;
#line 161 "Monitor.c"
			{
				gdouble* scale_collection = NULL;
				gint scale_collection_length1 = 0;
				gint _scale_collection_size_ = 0;
				gint scale_it = 0;
#line 64 "../src/Objects/Monitor.vala"
				scale_collection = _tmp9_;
#line 64 "../src/Objects/Monitor.vala"
				scale_collection_length1 = _tmp9__length1;
#line 64 "../src/Objects/Monitor.vala"
				for (scale_it = 0; scale_it < scale_collection_length1; scale_it = scale_it + 1) {
#line 173 "Monitor.c"
					gdouble scale = 0.0;
#line 64 "../src/Objects/Monitor.vala"
					scale = scale_collection[scale_it];
#line 177 "Monitor.c"
					{
#line 65 "../src/Objects/Monitor.vala"
						max_scale = MAX (max_scale, scale);
#line 181 "Monitor.c"
					}
				}
			}
#line 63 "../src/Objects/Monitor.vala"
			_g_object_unref0 (mode);
#line 187 "Monitor.c"
		}
	}
#line 69 "../src/Objects/Monitor.vala"
	result = max_scale;
#line 69 "../src/Objects/Monitor.vala"
	return result;
#line 194 "Monitor.c"
}

DisplayMonitorMode*
display_monitor_get_mode_by_id (DisplayMonitor* self,
                                const gchar* id)
{
	DisplayMonitorMode* result;
#line 76 "../src/Objects/Monitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 76 "../src/Objects/Monitor.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 206 "Monitor.c"
	{
		GeeLinkedList* _mode_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _mode_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _mode_index = 0;
#line 77 "../src/Objects/Monitor.vala"
		_tmp0_ = self->priv->_modes;
#line 77 "../src/Objects/Monitor.vala"
		_mode_list = _tmp0_;
#line 77 "../src/Objects/Monitor.vala"
		_tmp1_ = _mode_list;
#line 77 "../src/Objects/Monitor.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 77 "../src/Objects/Monitor.vala"
		_tmp3_ = _tmp2_;
#line 77 "../src/Objects/Monitor.vala"
		_mode_size = _tmp3_;
#line 77 "../src/Objects/Monitor.vala"
		_mode_index = -1;
#line 77 "../src/Objects/Monitor.vala"
		while (TRUE) {
#line 231 "Monitor.c"
			gint _tmp4_;
			gint _tmp5_;
			DisplayMonitorMode* mode = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			DisplayMonitorMode* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
#line 77 "../src/Objects/Monitor.vala"
			_mode_index = _mode_index + 1;
#line 77 "../src/Objects/Monitor.vala"
			_tmp4_ = _mode_index;
#line 77 "../src/Objects/Monitor.vala"
			_tmp5_ = _mode_size;
#line 77 "../src/Objects/Monitor.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 77 "../src/Objects/Monitor.vala"
				break;
#line 250 "Monitor.c"
			}
#line 77 "../src/Objects/Monitor.vala"
			_tmp6_ = _mode_list;
#line 77 "../src/Objects/Monitor.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _mode_index);
#line 77 "../src/Objects/Monitor.vala"
			mode = (DisplayMonitorMode*) _tmp7_;
#line 78 "../src/Objects/Monitor.vala"
			_tmp8_ = mode;
#line 78 "../src/Objects/Monitor.vala"
			_tmp9_ = display_monitor_mode_get_id (_tmp8_);
#line 78 "../src/Objects/Monitor.vala"
			_tmp10_ = _tmp9_;
#line 78 "../src/Objects/Monitor.vala"
			if (g_strcmp0 (_tmp10_, id) == 0) {
#line 79 "../src/Objects/Monitor.vala"
				result = mode;
#line 79 "../src/Objects/Monitor.vala"
				return result;
#line 270 "Monitor.c"
			}
#line 77 "../src/Objects/Monitor.vala"
			_g_object_unref0 (mode);
#line 274 "Monitor.c"
		}
	}
#line 83 "../src/Objects/Monitor.vala"
	result = NULL;
#line 83 "../src/Objects/Monitor.vala"
	return result;
#line 281 "Monitor.c"
}

DisplayMonitor*
display_monitor_construct (GType object_type)
{
	DisplayMonitor * self = NULL;
#line 22 "../src/Objects/Monitor.vala"
	self = (DisplayMonitor*) g_object_new (object_type, NULL);
#line 22 "../src/Objects/Monitor.vala"
	return self;
#line 292 "Monitor.c"
}

DisplayMonitor*
display_monitor_new (void)
{
#line 22 "../src/Objects/Monitor.vala"
	return display_monitor_construct (DISPLAY_TYPE_MONITOR);
#line 300 "Monitor.c"
}

const gchar*
display_monitor_get_connector (DisplayMonitor* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../src/Objects/Monitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Objects/Monitor.vala"
	_tmp0_ = self->priv->_connector;
#line 23 "../src/Objects/Monitor.vala"
	result = _tmp0_;
#line 23 "../src/Objects/Monitor.vala"
	return result;
#line 316 "Monitor.c"
}

void
display_monitor_set_connector (DisplayMonitor* self,
                               const gchar* value)
{
	gchar* old_value;
#line 23 "../src/Objects/Monitor.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Objects/Monitor.vala"
	old_value = display_monitor_get_connector (self);
#line 23 "../src/Objects/Monitor.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 330 "Monitor.c"
		gchar* _tmp0_;
#line 23 "../src/Objects/Monitor.vala"
		_tmp0_ = g_strdup (value);
#line 23 "../src/Objects/Monitor.vala"
		_g_free0 (self->priv->_connector);
#line 23 "../src/Objects/Monitor.vala"
		self->priv->_connector = _tmp0_;
#line 23 "../src/Objects/Monitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_properties[DISPLAY_MONITOR_CONNECTOR_PROPERTY]);
#line 340 "Monitor.c"
	}
}

const gchar*
display_monitor_get_vendor (DisplayMonitor* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 24 "../src/Objects/Monitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/Objects/Monitor.vala"
	_tmp0_ = self->priv->_vendor;
#line 24 "../src/Objects/Monitor.vala"
	result = _tmp0_;
#line 24 "../src/Objects/Monitor.vala"
	return result;
#line 357 "Monitor.c"
}

void
display_monitor_set_vendor (DisplayMonitor* self,
                            const gchar* value)
{
	gchar* old_value;
#line 24 "../src/Objects/Monitor.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Objects/Monitor.vala"
	old_value = display_monitor_get_vendor (self);
#line 24 "../src/Objects/Monitor.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 371 "Monitor.c"
		gchar* _tmp0_;
#line 24 "../src/Objects/Monitor.vala"
		_tmp0_ = g_strdup (value);
#line 24 "../src/Objects/Monitor.vala"
		_g_free0 (self->priv->_vendor);
#line 24 "../src/Objects/Monitor.vala"
		self->priv->_vendor = _tmp0_;
#line 24 "../src/Objects/Monitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_properties[DISPLAY_MONITOR_VENDOR_PROPERTY]);
#line 381 "Monitor.c"
	}
}

const gchar*
display_monitor_get_product (DisplayMonitor* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 25 "../src/Objects/Monitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/Objects/Monitor.vala"
	_tmp0_ = self->priv->_product;
#line 25 "../src/Objects/Monitor.vala"
	result = _tmp0_;
#line 25 "../src/Objects/Monitor.vala"
	return result;
#line 398 "Monitor.c"
}

void
display_monitor_set_product (DisplayMonitor* self,
                             const gchar* value)
{
	gchar* old_value;
#line 25 "../src/Objects/Monitor.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Objects/Monitor.vala"
	old_value = display_monitor_get_product (self);
#line 25 "../src/Objects/Monitor.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 412 "Monitor.c"
		gchar* _tmp0_;
#line 25 "../src/Objects/Monitor.vala"
		_tmp0_ = g_strdup (value);
#line 25 "../src/Objects/Monitor.vala"
		_g_free0 (self->priv->_product);
#line 25 "../src/Objects/Monitor.vala"
		self->priv->_product = _tmp0_;
#line 25 "../src/Objects/Monitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_properties[DISPLAY_MONITOR_PRODUCT_PROPERTY]);
#line 422 "Monitor.c"
	}
}

const gchar*
display_monitor_get_serial (DisplayMonitor* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "../src/Objects/Monitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/Objects/Monitor.vala"
	_tmp0_ = self->priv->_serial;
#line 26 "../src/Objects/Monitor.vala"
	result = _tmp0_;
#line 26 "../src/Objects/Monitor.vala"
	return result;
#line 439 "Monitor.c"
}

void
display_monitor_set_serial (DisplayMonitor* self,
                            const gchar* value)
{
	gchar* old_value;
#line 26 "../src/Objects/Monitor.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Objects/Monitor.vala"
	old_value = display_monitor_get_serial (self);
#line 26 "../src/Objects/Monitor.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 453 "Monitor.c"
		gchar* _tmp0_;
#line 26 "../src/Objects/Monitor.vala"
		_tmp0_ = g_strdup (value);
#line 26 "../src/Objects/Monitor.vala"
		_g_free0 (self->priv->_serial);
#line 26 "../src/Objects/Monitor.vala"
		self->priv->_serial = _tmp0_;
#line 26 "../src/Objects/Monitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_properties[DISPLAY_MONITOR_SERIAL_PROPERTY]);
#line 463 "Monitor.c"
	}
}

guint
display_monitor_get_hash (DisplayMonitor* self)
{
	guint result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	guint _tmp10_;
#line 28 "../src/Objects/Monitor.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 29 "../src/Objects/Monitor.vala"
	_tmp0_ = self->priv->_connector;
#line 29 "../src/Objects/Monitor.vala"
	_tmp1_ = self->priv->_vendor;
#line 29 "../src/Objects/Monitor.vala"
	_tmp2_ = g_strconcat (_tmp0_, _tmp1_, NULL);
#line 29 "../src/Objects/Monitor.vala"
	_tmp3_ = _tmp2_;
#line 29 "../src/Objects/Monitor.vala"
	_tmp4_ = self->priv->_product;
#line 29 "../src/Objects/Monitor.vala"
	_tmp5_ = g_strconcat (_tmp3_, _tmp4_, NULL);
#line 29 "../src/Objects/Monitor.vala"
	_tmp6_ = _tmp5_;
#line 29 "../src/Objects/Monitor.vala"
	_tmp7_ = self->priv->_serial;
#line 29 "../src/Objects/Monitor.vala"
	_tmp8_ = g_strconcat (_tmp6_, _tmp7_, NULL);
#line 29 "../src/Objects/Monitor.vala"
	_tmp9_ = _tmp8_;
#line 29 "../src/Objects/Monitor.vala"
	_tmp10_ = g_str_hash (_tmp9_);
#line 29 "../src/Objects/Monitor.vala"
	_g_free0 (_tmp9_);
#line 29 "../src/Objects/Monitor.vala"
	_g_free0 (_tmp6_);
#line 29 "../src/Objects/Monitor.vala"
	_g_free0 (_tmp3_);
#line 29 "../src/Objects/Monitor.vala"
	result = _tmp10_;
#line 29 "../src/Objects/Monitor.vala"
	return result;
#line 516 "Monitor.c"
}

const gchar*
display_monitor_get_display_name (DisplayMonitor* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../src/Objects/Monitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/Objects/Monitor.vala"
	_tmp0_ = self->priv->_display_name;
#line 33 "../src/Objects/Monitor.vala"
	result = _tmp0_;
#line 33 "../src/Objects/Monitor.vala"
	return result;
#line 532 "Monitor.c"
}

void
display_monitor_set_display_name (DisplayMonitor* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 33 "../src/Objects/Monitor.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Objects/Monitor.vala"
	old_value = display_monitor_get_display_name (self);
#line 33 "../src/Objects/Monitor.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 546 "Monitor.c"
		gchar* _tmp0_;
#line 33 "../src/Objects/Monitor.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../src/Objects/Monitor.vala"
		_g_free0 (self->priv->_display_name);
#line 33 "../src/Objects/Monitor.vala"
		self->priv->_display_name = _tmp0_;
#line 33 "../src/Objects/Monitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_properties[DISPLAY_MONITOR_DISPLAY_NAME_PROPERTY]);
#line 556 "Monitor.c"
	}
}

gboolean
display_monitor_get_is_builtin (DisplayMonitor* self)
{
	gboolean result;
#line 34 "../src/Objects/Monitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "../src/Objects/Monitor.vala"
	result = self->priv->_is_builtin;
#line 34 "../src/Objects/Monitor.vala"
	return result;
#line 570 "Monitor.c"
}

void
display_monitor_set_is_builtin (DisplayMonitor* self,
                                gboolean value)
{
	gboolean old_value;
#line 34 "../src/Objects/Monitor.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Objects/Monitor.vala"
	old_value = display_monitor_get_is_builtin (self);
#line 34 "../src/Objects/Monitor.vala"
	if (old_value != value) {
#line 34 "../src/Objects/Monitor.vala"
		self->priv->_is_builtin = value;
#line 34 "../src/Objects/Monitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_properties[DISPLAY_MONITOR_IS_BUILTIN_PROPERTY]);
#line 588 "Monitor.c"
	}
}

GeeLinkedList*
display_monitor_get_modes (DisplayMonitor* self)
{
	GeeLinkedList* result;
	GeeLinkedList* _tmp0_;
#line 35 "../src/Objects/Monitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Objects/Monitor.vala"
	_tmp0_ = self->priv->_modes;
#line 35 "../src/Objects/Monitor.vala"
	result = _tmp0_;
#line 35 "../src/Objects/Monitor.vala"
	return result;
#line 605 "Monitor.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 35 "../src/Objects/Monitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 613 "Monitor.c"
}

static void
display_monitor_set_modes (DisplayMonitor* self,
                           GeeLinkedList* value)
{
	GeeLinkedList* old_value;
#line 35 "../src/Objects/Monitor.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Objects/Monitor.vala"
	old_value = display_monitor_get_modes (self);
#line 35 "../src/Objects/Monitor.vala"
	if (old_value != value) {
#line 627 "Monitor.c"
		GeeLinkedList* _tmp0_;
#line 35 "../src/Objects/Monitor.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 35 "../src/Objects/Monitor.vala"
		_g_object_unref0 (self->priv->_modes);
#line 35 "../src/Objects/Monitor.vala"
		self->priv->_modes = _tmp0_;
#line 35 "../src/Objects/Monitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_properties[DISPLAY_MONITOR_MODES_PROPERTY]);
#line 637 "Monitor.c"
	}
}

DisplayMonitorMode*
display_monitor_get_current_mode (DisplayMonitor* self)
{
	DisplayMonitorMode* result;
	GeeLinkedList* _tmp11_;
	gpointer _tmp12_;
#line 38 "../src/Objects/Monitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 649 "Monitor.c"
	{
		GeeLinkedList* _mode_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _mode_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _mode_index = 0;
#line 39 "../src/Objects/Monitor.vala"
		_tmp0_ = self->priv->_modes;
#line 39 "../src/Objects/Monitor.vala"
		_mode_list = _tmp0_;
#line 39 "../src/Objects/Monitor.vala"
		_tmp1_ = _mode_list;
#line 39 "../src/Objects/Monitor.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 39 "../src/Objects/Monitor.vala"
		_tmp3_ = _tmp2_;
#line 39 "../src/Objects/Monitor.vala"
		_mode_size = _tmp3_;
#line 39 "../src/Objects/Monitor.vala"
		_mode_index = -1;
#line 39 "../src/Objects/Monitor.vala"
		while (TRUE) {
#line 674 "Monitor.c"
			gint _tmp4_;
			gint _tmp5_;
			DisplayMonitorMode* mode = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			DisplayMonitorMode* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 39 "../src/Objects/Monitor.vala"
			_mode_index = _mode_index + 1;
#line 39 "../src/Objects/Monitor.vala"
			_tmp4_ = _mode_index;
#line 39 "../src/Objects/Monitor.vala"
			_tmp5_ = _mode_size;
#line 39 "../src/Objects/Monitor.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 39 "../src/Objects/Monitor.vala"
				break;
#line 693 "Monitor.c"
			}
#line 39 "../src/Objects/Monitor.vala"
			_tmp6_ = _mode_list;
#line 39 "../src/Objects/Monitor.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _mode_index);
#line 39 "../src/Objects/Monitor.vala"
			mode = (DisplayMonitorMode*) _tmp7_;
#line 40 "../src/Objects/Monitor.vala"
			_tmp8_ = mode;
#line 40 "../src/Objects/Monitor.vala"
			_tmp9_ = display_monitor_mode_get_is_current (_tmp8_);
#line 40 "../src/Objects/Monitor.vala"
			_tmp10_ = _tmp9_;
#line 40 "../src/Objects/Monitor.vala"
			if (_tmp10_) {
#line 41 "../src/Objects/Monitor.vala"
				result = mode;
#line 41 "../src/Objects/Monitor.vala"
				return result;
#line 713 "Monitor.c"
			}
#line 39 "../src/Objects/Monitor.vala"
			_g_object_unref0 (mode);
#line 717 "Monitor.c"
		}
	}
#line 45 "../src/Objects/Monitor.vala"
	_tmp11_ = self->priv->_modes;
#line 45 "../src/Objects/Monitor.vala"
	_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, 0);
#line 45 "../src/Objects/Monitor.vala"
	result = (DisplayMonitorMode*) _tmp12_;
#line 45 "../src/Objects/Monitor.vala"
	return result;
#line 728 "Monitor.c"
}

DisplayMonitorMode*
display_monitor_get_preferred_mode (DisplayMonitor* self)
{
	DisplayMonitorMode* result;
	GeeLinkedList* _tmp11_;
	gpointer _tmp12_;
#line 50 "../src/Objects/Monitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 739 "Monitor.c"
	{
		GeeLinkedList* _mode_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _mode_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _mode_index = 0;
#line 51 "../src/Objects/Monitor.vala"
		_tmp0_ = self->priv->_modes;
#line 51 "../src/Objects/Monitor.vala"
		_mode_list = _tmp0_;
#line 51 "../src/Objects/Monitor.vala"
		_tmp1_ = _mode_list;
#line 51 "../src/Objects/Monitor.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 51 "../src/Objects/Monitor.vala"
		_tmp3_ = _tmp2_;
#line 51 "../src/Objects/Monitor.vala"
		_mode_size = _tmp3_;
#line 51 "../src/Objects/Monitor.vala"
		_mode_index = -1;
#line 51 "../src/Objects/Monitor.vala"
		while (TRUE) {
#line 764 "Monitor.c"
			gint _tmp4_;
			gint _tmp5_;
			DisplayMonitorMode* mode = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			DisplayMonitorMode* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 51 "../src/Objects/Monitor.vala"
			_mode_index = _mode_index + 1;
#line 51 "../src/Objects/Monitor.vala"
			_tmp4_ = _mode_index;
#line 51 "../src/Objects/Monitor.vala"
			_tmp5_ = _mode_size;
#line 51 "../src/Objects/Monitor.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 51 "../src/Objects/Monitor.vala"
				break;
#line 783 "Monitor.c"
			}
#line 51 "../src/Objects/Monitor.vala"
			_tmp6_ = _mode_list;
#line 51 "../src/Objects/Monitor.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _mode_index);
#line 51 "../src/Objects/Monitor.vala"
			mode = (DisplayMonitorMode*) _tmp7_;
#line 52 "../src/Objects/Monitor.vala"
			_tmp8_ = mode;
#line 52 "../src/Objects/Monitor.vala"
			_tmp9_ = display_monitor_mode_get_is_preferred (_tmp8_);
#line 52 "../src/Objects/Monitor.vala"
			_tmp10_ = _tmp9_;
#line 52 "../src/Objects/Monitor.vala"
			if (_tmp10_) {
#line 53 "../src/Objects/Monitor.vala"
				result = mode;
#line 53 "../src/Objects/Monitor.vala"
				return result;
#line 803 "Monitor.c"
			}
#line 51 "../src/Objects/Monitor.vala"
			_g_object_unref0 (mode);
#line 807 "Monitor.c"
		}
	}
#line 57 "../src/Objects/Monitor.vala"
	_tmp11_ = self->priv->_modes;
#line 57 "../src/Objects/Monitor.vala"
	_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, 0);
#line 57 "../src/Objects/Monitor.vala"
	result = (DisplayMonitorMode*) _tmp12_;
#line 57 "../src/Objects/Monitor.vala"
	return result;
#line 818 "Monitor.c"
}

static GObject *
display_monitor_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DisplayMonitor * self;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
#line 72 "../src/Objects/Monitor.vala"
	parent_class = G_OBJECT_CLASS (display_monitor_parent_class);
#line 72 "../src/Objects/Monitor.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 72 "../src/Objects/Monitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_MONITOR, DisplayMonitor);
#line 73 "../src/Objects/Monitor.vala"
	_tmp0_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR_MODE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 73 "../src/Objects/Monitor.vala"
	_tmp1_ = _tmp0_;
#line 73 "../src/Objects/Monitor.vala"
	display_monitor_set_modes (self, _tmp1_);
#line 73 "../src/Objects/Monitor.vala"
	_g_object_unref0 (_tmp1_);
#line 72 "../src/Objects/Monitor.vala"
	return obj;
#line 847 "Monitor.c"
}

static void
display_monitor_class_init (DisplayMonitorClass * klass,
                            gpointer klass_data)
{
#line 22 "../src/Objects/Monitor.vala"
	display_monitor_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Objects/Monitor.vala"
	g_type_class_adjust_private_offset (klass, &DisplayMonitor_private_offset);
#line 22 "../src/Objects/Monitor.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_display_monitor_get_property;
#line 22 "../src/Objects/Monitor.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_display_monitor_set_property;
#line 22 "../src/Objects/Monitor.vala"
	G_OBJECT_CLASS (klass)->constructor = display_monitor_constructor;
#line 22 "../src/Objects/Monitor.vala"
	G_OBJECT_CLASS (klass)->finalize = display_monitor_finalize;
#line 22 "../src/Objects/Monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_CONNECTOR_PROPERTY, display_monitor_properties[DISPLAY_MONITOR_CONNECTOR_PROPERTY] = g_param_spec_string ("connector", "connector", "connector", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_VENDOR_PROPERTY, display_monitor_properties[DISPLAY_MONITOR_VENDOR_PROPERTY] = g_param_spec_string ("vendor", "vendor", "vendor", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_PRODUCT_PROPERTY, display_monitor_properties[DISPLAY_MONITOR_PRODUCT_PROPERTY] = g_param_spec_string ("product", "product", "product", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_SERIAL_PROPERTY, display_monitor_properties[DISPLAY_MONITOR_SERIAL_PROPERTY] = g_param_spec_string ("serial", "serial", "serial", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_HASH_PROPERTY, display_monitor_properties[DISPLAY_MONITOR_HASH_PROPERTY] = g_param_spec_uint ("hash", "hash", "hash", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Objects/Monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_DISPLAY_NAME_PROPERTY, display_monitor_properties[DISPLAY_MONITOR_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_IS_BUILTIN_PROPERTY, display_monitor_properties[DISPLAY_MONITOR_IS_BUILTIN_PROPERTY] = g_param_spec_boolean ("is-builtin", "is-builtin", "is-builtin", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MODES_PROPERTY, display_monitor_properties[DISPLAY_MONITOR_MODES_PROPERTY] = g_param_spec_object ("modes", "modes", "modes", GEE_TYPE_LINKED_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Objects/Monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_CURRENT_MODE_PROPERTY, display_monitor_properties[DISPLAY_MONITOR_CURRENT_MODE_PROPERTY] = g_param_spec_object ("current-mode", "current-mode", "current-mode", DISPLAY_TYPE_MONITOR_MODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Objects/Monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_PREFERRED_MODE_PROPERTY, display_monitor_properties[DISPLAY_MONITOR_PREFERRED_MODE_PROPERTY] = g_param_spec_object ("preferred-mode", "preferred-mode", "preferred-mode", DISPLAY_TYPE_MONITOR_MODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 886 "Monitor.c"
}

static void
display_monitor_instance_init (DisplayMonitor * self,
                               gpointer klass)
{
#line 22 "../src/Objects/Monitor.vala"
	self->priv = display_monitor_get_instance_private (self);
#line 895 "Monitor.c"
}

static void
display_monitor_finalize (GObject * obj)
{
	DisplayMonitor * self;
#line 22 "../src/Objects/Monitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_MONITOR, DisplayMonitor);
#line 23 "../src/Objects/Monitor.vala"
	_g_free0 (self->priv->_connector);
#line 24 "../src/Objects/Monitor.vala"
	_g_free0 (self->priv->_vendor);
#line 25 "../src/Objects/Monitor.vala"
	_g_free0 (self->priv->_product);
#line 26 "../src/Objects/Monitor.vala"
	_g_free0 (self->priv->_serial);
#line 33 "../src/Objects/Monitor.vala"
	_g_free0 (self->priv->_display_name);
#line 35 "../src/Objects/Monitor.vala"
	_g_object_unref0 (self->priv->_modes);
#line 22 "../src/Objects/Monitor.vala"
	G_OBJECT_CLASS (display_monitor_parent_class)->finalize (obj);
#line 918 "Monitor.c"
}

static GType
display_monitor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayMonitor), 0, (GInstanceInitFunc) display_monitor_instance_init, NULL };
	GType display_monitor_type_id;
	display_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "DisplayMonitor", &g_define_type_info, 0);
	DisplayMonitor_private_offset = g_type_add_instance_private (display_monitor_type_id, sizeof (DisplayMonitorPrivate));
	return display_monitor_type_id;
}

GType
display_monitor_get_type (void)
{
	static volatile gsize display_monitor_type_id__once = 0;
	if (g_once_init_enter (&display_monitor_type_id__once)) {
		GType display_monitor_type_id;
		display_monitor_type_id = display_monitor_get_type_once ();
		g_once_init_leave (&display_monitor_type_id__once, display_monitor_type_id);
	}
	return display_monitor_type_id__once;
}

static void
_vala_display_monitor_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	DisplayMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_MONITOR, DisplayMonitor);
#line 22 "../src/Objects/Monitor.vala"
	switch (property_id) {
#line 22 "../src/Objects/Monitor.vala"
		case DISPLAY_MONITOR_CONNECTOR_PROPERTY:
#line 22 "../src/Objects/Monitor.vala"
		g_value_set_string (value, display_monitor_get_connector (self));
#line 22 "../src/Objects/Monitor.vala"
		break;
#line 22 "../src/Objects/Monitor.vala"
		case DISPLAY_MONITOR_VENDOR_PROPERTY:
#line 22 "../src/Objects/Monitor.vala"
		g_value_set_string (value, display_monitor_get_vendor (self));
#line 22 "../src/Objects/Monitor.vala"
		break;
#line 22 "../src/Objects/Monitor.vala"
		case DISPLAY_MONITOR_PRODUCT_PROPERTY:
#line 22 "../src/Objects/Monitor.vala"
		g_value_set_string (value, display_monitor_get_product (self));
#line 22 "../src/Objects/Monitor.vala"
		break;
#line 22 "../src/Objects/Monitor.vala"
		case DISPLAY_MONITOR_SERIAL_PROPERTY:
#line 22 "../src/Objects/Monitor.vala"
		g_value_set_string (value, display_monitor_get_serial (self));
#line 22 "../src/Objects/Monitor.vala"
		break;
#line 22 "../src/Objects/Monitor.vala"
		case DISPLAY_MONITOR_HASH_PROPERTY:
#line 22 "../src/Objects/Monitor.vala"
		g_value_set_uint (value, display_monitor_get_hash (self));
#line 22 "../src/Objects/Monitor.vala"
		break;
#line 22 "../src/Objects/Monitor.vala"
		case DISPLAY_MONITOR_DISPLAY_NAME_PROPERTY:
#line 22 "../src/Objects/Monitor.vala"
		g_value_set_string (value, display_monitor_get_display_name (self));
#line 22 "../src/Objects/Monitor.vala"
		break;
#line 22 "../src/Objects/Monitor.vala"
		case DISPLAY_MONITOR_IS_BUILTIN_PROPERTY:
#line 22 "../src/Objects/Monitor.vala"
		g_value_set_boolean (value, display_monitor_get_is_builtin (self));
#line 22 "../src/Objects/Monitor.vala"
		break;
#line 22 "../src/Objects/Monitor.vala"
		case DISPLAY_MONITOR_MODES_PROPERTY:
#line 22 "../src/Objects/Monitor.vala"
		g_value_set_object (value, display_monitor_get_modes (self));
#line 22 "../src/Objects/Monitor.vala"
		break;
#line 22 "../src/Objects/Monitor.vala"
		case DISPLAY_MONITOR_CURRENT_MODE_PROPERTY:
#line 22 "../src/Objects/Monitor.vala"
		g_value_take_object (value, display_monitor_get_current_mode (self));
#line 22 "../src/Objects/Monitor.vala"
		break;
#line 22 "../src/Objects/Monitor.vala"
		case DISPLAY_MONITOR_PREFERRED_MODE_PROPERTY:
#line 22 "../src/Objects/Monitor.vala"
		g_value_take_object (value, display_monitor_get_preferred_mode (self));
#line 22 "../src/Objects/Monitor.vala"
		break;
#line 1013 "Monitor.c"
		default:
#line 22 "../src/Objects/Monitor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Objects/Monitor.vala"
		break;
#line 1019 "Monitor.c"
	}
}

static void
_vala_display_monitor_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	DisplayMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_MONITOR, DisplayMonitor);
#line 22 "../src/Objects/Monitor.vala"
	switch (property_id) {
#line 22 "../src/Objects/Monitor.vala"
		case DISPLAY_MONITOR_CONNECTOR_PROPERTY:
#line 22 "../src/Objects/Monitor.vala"
		display_monitor_set_connector (self, g_value_get_string (value));
#line 22 "../src/Objects/Monitor.vala"
		break;
#line 22 "../src/Objects/Monitor.vala"
		case DISPLAY_MONITOR_VENDOR_PROPERTY:
#line 22 "../src/Objects/Monitor.vala"
		display_monitor_set_vendor (self, g_value_get_string (value));
#line 22 "../src/Objects/Monitor.vala"
		break;
#line 22 "../src/Objects/Monitor.vala"
		case DISPLAY_MONITOR_PRODUCT_PROPERTY:
#line 22 "../src/Objects/Monitor.vala"
		display_monitor_set_product (self, g_value_get_string (value));
#line 22 "../src/Objects/Monitor.vala"
		break;
#line 22 "../src/Objects/Monitor.vala"
		case DISPLAY_MONITOR_SERIAL_PROPERTY:
#line 22 "../src/Objects/Monitor.vala"
		display_monitor_set_serial (self, g_value_get_string (value));
#line 22 "../src/Objects/Monitor.vala"
		break;
#line 22 "../src/Objects/Monitor.vala"
		case DISPLAY_MONITOR_DISPLAY_NAME_PROPERTY:
#line 22 "../src/Objects/Monitor.vala"
		display_monitor_set_display_name (self, g_value_get_string (value));
#line 22 "../src/Objects/Monitor.vala"
		break;
#line 22 "../src/Objects/Monitor.vala"
		case DISPLAY_MONITOR_IS_BUILTIN_PROPERTY:
#line 22 "../src/Objects/Monitor.vala"
		display_monitor_set_is_builtin (self, g_value_get_boolean (value));
#line 22 "../src/Objects/Monitor.vala"
		break;
#line 22 "../src/Objects/Monitor.vala"
		case DISPLAY_MONITOR_MODES_PROPERTY:
#line 22 "../src/Objects/Monitor.vala"
		display_monitor_set_modes (self, g_value_get_object (value));
#line 22 "../src/Objects/Monitor.vala"
		break;
#line 1075 "Monitor.c"
		default:
#line 22 "../src/Objects/Monitor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Objects/Monitor.vala"
		break;
#line 1081 "Monitor.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

